//AnimalStuff
//Animal walks while moving forward, back, left, right, turning.
//Animal can talk
//Unfriendly animal will chase you if you get too close to it.

ENTITY * p_animal; //pointer to animal entity
SOUND * p_animal_talk = "jim.wav"; //pointer to animal speech
SOUND * p_animal_growl = "growl.wav"; // pointer to animal growl

var talk_handle;  //handle to talk sound file
var growl_handle; //handle to growl sound file
var walk_speed;   //speed to animate walk bones
var talk_speed;	// speed to animate talking animal
var nod_speed;		// speed to nod animal head 
var shake_speed;	// speed to shake animal head

//animal speech/dialog/sound when it talks
function talk_sound()
{
	if(!snd_playing(talk_handle))// don't keep restarting sound
  {
	talk_handle = snd_play(p_animal_talk,20,50); // change snd settings to suit
  }// end if
   
}

//animate the animal walking bones
function walk_anim()
{
	ent_animate(my, NULL, 0, 0); // reset all the animations
	walk_speed += 20 * time_step; // increase walk_speed; 1.5 sets the speed
  	ent_animate(my, "Walk", walk_speed, ANM_CYCLE); // animate the model (use "Walk")
}

//animate the animal talking bones
function talk_anim()
{
	ent_animate(my, NULL, 0, 0); // reset all the animations
	talk_speed += 20 * time_step; // increase walk_speed; 1.5 sets the speed
  	ent_animate(my, "Talk", talk_speed, ANM_CYCLE); // animate the model (use "Talk")
}

//animate the animal head nod bones
function nod_anim()
{
	ent_animate(my, NULL, 0, 0); // reset all the animations
	nod_speed += 20 * time_step; // increase walk_speed; 1.5 sets the speed
  	ent_animate(my, "Nod", nod_speed, ANM_CYCLE); // animate the model (use "Nod")
}

//animate the animal head shake bones
function shake_anim()
{
	ent_animate(my, NULL, 0, 0); // reset all the animations
	shake_speed += 20 * time_step; // increase walk_speed; 1.5 sets the speed
  	ent_animate(my, "Shake", shake_speed, ANM_CYCLE); // animate the model (use "Shake")
}

//use keyboard to move animal.
//move animal forward, back, left, right, and turn.
function move_animal()
{
	//use c_move for collison detection
	
	while(1)
	{
	
	if (key_w) 
	{
	 c_move(me,vector(3* time_step,0,0),nullvector,GLIDE);// forward
	 walk_anim();
	}
	
	if (key_s) 
	{
	  c_move(me,vector(-3* time_step,0,0),nullvector,GLIDE);//backward
	  walk_anim();
	}
	
	if (key_d)
	{
	 c_move(me,vector(0,-3* time_step,0),nullvector,GLIDE); //right
	 walk_anim();
 	}
 	
	if (key_a)
	{
	 c_move(me,vector(0,3* time_step,0),nullvector,GLIDE); //left
	 walk_anim();
 	}
 	
	if (key_z)c_move(me,vector(0,0,3* time_step),nullvector,GLIDE); //up
	if (key_c) c_move(me,vector(0,0,-3* time_step),nullvector,GLIDE); //down
	
	//pan, look around
	if (key_q) {my.pan += 2*time_step;walk_anim();}
	if (key_e) {my.pan -= 2*time_step;walk_anim();}
	
	wait(1);
	}
}//end function walk_animal

//use keyboard to play animal talk, nod head, shake head.
function play_animal()
{
	
	while(1)
	{
	
	if (key_t) 
	{
	 talk_anim();   // animal talk animation
	 talk_sound(); //play animal talk speech
	}
	else
	{
		snd_pause(talk_handle); // stop talk if no talk key
	}
	
	if (key_n) 
	{
	 nod_anim();
	}
	
	if (key_b)
	{
	 shake_anim();
 	}
 	
 		
	wait(1);
	}// end while
	
	if(!key_t)
 	snd_stop(talk_handle);//stop animal talk / speech / sound
}//end function play_animal

//action for animal that doesn't attack
action animal_nice()
{
	
if(!player)
{
 wait(1); //while player loads
}
	
p_animal = me;
move_animal();
play_animal();

//add apparent gravity
while(1)
{
c_move(me,nullvector,vector(0,0,-2*time_step),GLIDE);
wait(1);
}

}

/********************************************************/
/*********** Added Bad Animal Here **********************/

function bad_animal_attack()
{
	// See AUM 73 questions for more following and vector movement
	wait(1); // so c_move will work
   c_move (my, vector(6 * time_step, 0, 0), nullvector, GLIDE);
}

//bad animal growl sound when it attacks
function growl_sound()
{
	
	if(!snd_playing(growl_handle))// don't keep restarting sound while growling
  {
  	growl_handle = snd_play(p_animal_growl,20,50); // change snd settings to suit
  }// end if
   
}

// animate animal bones to look like bad animal
function bad_animal_anims()
{
	static var walk_percentage, talk_percentage;
	ent_animate(my, "walk", walk_percentage, ANM_CYCLE);
   walk_percentage += 15 * time_step; // controls the "walk" animation speed
   
   static var  nod_percentage;
	ent_animate(my, "nod", nod_percentage, ANM_ADD); //looks like animal biting
   talk_percentage += 15 * time_step; // controls the "nod" animation speed 
}

// sets off bad animal behaviour if animal is scanned
function scan_animal()
{
	  
  while(event_type == EVENT_SCAN)
  {
  	    
  //make a vector to the player position
  var px = player.x;
  var py = player.y;
  var pz = player.z;
  var your_location[3]; 
  your_location[0] = px;
  your_location[1] = py;
  your_location[2] = pz;
  	
  	
  	// the animal is rotated in the proper direction here
  	VECTOR temp_dest;
  	vec_set(temp_dest,your_location);
  	vec_sub(temp_dest, my.x);
   vec_to_angle(my.pan, temp_dest); 
   my.tilt = 0;
         
	// the animal attacks player
	bad_animal_attack(); //  uses c_move instruction
   bad_animal_anims();      
   growl_sound();//animal sound for attack / chase
  
   //player can last a little while being chased, but must escape to live
   player.skill10 -= 2*time_step; 
   wait (-30);// play with. If player survives > 30 sec without escape, may get growl sound effects
	snd_stop(growl_handle); // stop growl if not chasing player
   	
  	wait(1);
	}//end while
	
	
 }// end function

//action for animal that does attack
action animal_bad()
{
	if(!player)
	{
	wait(1); //while player loads
	}
	
 	p_animal = my;
 	 	
 	// animal does stuff
 	my.emask = ENABLE_SCAN| EVENT_SCAN; // sensible for scans from player
 	my.event = scan_animal; //bad reaction to scan from player
 		
	//add apparent gravity to bad animal
	while(1)
	{
	c_move(me,nullvector,vector(0,0,-2*time_step),GLIDE);
	wait(1);
	}//end while

}